# @qgame/adapter

----

## 为什么要将@qgame/adapter做成一个npm包

答: 之前的qgame-adapter.js本身并没有什么问题。不过在实际工作中，qgame-adapter.js是提供给厂商的（cocos、egret、laya等），之前我们在和这些厂商对接的时候是需要提供给他们这个文件，然后他们直接将该文件打包进他们的引擎里面的。这样当我们需要对某些部分做修改或者增强的时候，就需要重新写一个再发送给这些厂商等待他们们更新下一个版本的时候再次将该文件打包进去。

## 为什么要使用typescript重构@qgame/adapter

答: 因为我们在编写适配代码的时候，没有办法保证我们的adapter和标准是一致的。这里主要是方法名、入参、返回值、属性以及他们的类型等。使用typescript编写可以很大程度暴露与标准不一致的地方。

## @qgame/adapter的编写思路是什么

答: 因为我们的全局属性和标准是不一样的，因此采用noLib表明不要引入标准的定义库，而是自己定义adapte.d.ts，这里面主要是要定义我们需要兼容的变量的属性、方法的类型。
然后按照标准编写各个类，比如
`EventTarget <- Node <- CharacterData <- Text`
其实完全按照标准的属性来编写的话，会有大量的工作要做，但是其实还是有很多属性根本用不上，因此其实只要能覆盖到厂商里面涉及到的那些就可以了，其他的cp不会用到，厂商引擎里面没有涉及到的也可以直接先舍去，后面要支持的时候再加上。

## @qgame/adapter测试通过之后需要做的事情有哪些

答:
a. 根据标准版本的jsframework，看看是否有什么地方需要完善的，将jsframework中目前已经支持的的地方在`@qgame/adapte`r中舍去。
b. 看看是否有不应该在jsframework中的部分需要迁移到`@qgame/adapte`r中。
c. 因为现在的厂商都是在使用qgame-adapter.js，所以需要和各个厂商沟通，将之前的qgame-adapter.js改为以npm或者yarn引入@`qgame/adapter`的方式来引入，在这之前他们可以通过对比版本来判断是否需要更新之前已经引入的@`qgame/adapter`。
